<?php
// wcf imports
require_once(WCF_DIR.'lib/action/AbstractAction.class.php');
require_once(WCF_DIR.'lib/data/socialBookmark/SocialBookmarkProviderEditor.class.php');

/**
 * Deletes a social bookmark provider.
 * 
 * @author	Alexander Ebert
 * @copyright	2001-2010 WoltLab GmbH
 * @license	GNU Lesser General Public License <http://opensource.org/licenses/lgpl-license.php>
 * @package	com.woltlab.wcf.socialBookmarks
 * @subpackage	acp.action
 * @category 	Community Framework
 */
class SocialBookmarkProviderDeleteAction extends AbstractAction {
	/**
	 * social bookmark provider id
	 *
	 * @var	integer
	 */
	public $providerID = 0;
	
	/**
	 * social bookmark provider editor object
	 *
	 * @var	SocialBookmarkProviderEditor
	 */
	public $socialBookmarkProvider;
	
	/**
	 * @see Action::readParameters()
	 */
	public function readParameters() {
		parent::readParameters();
		
		if (isset($_REQUEST['providerID'])) $this->providerID = intval($_REQUEST['providerID']);
		$this->socialBookmarkProvider = new SocialBookmarkProviderEditor($this->providerID);
		if (!$this->socialBookmarkProvider->providerID) {
			throw new IllegalLinkException();
		}
	}
	
	/**
	 * @see Action::execute()
	 */
	public function execute() {
		parent::execute();
		
		// check permission
		WCF::getUser()->checkPermission('admin.socialBookmark.canDeleteSocialBookmarkProvider');
		
		// delete category
		$this->socialBookmarkProvider->delete();
		$this->executed();
		
		// clear cache
		WCF::getCache()->clear(WCF_DIR.'cache/', 'cache.socialBookmarkProvider.php');
		
		// forward to list page
		HeaderUtil::redirect('index.php?page=SocialBookmarkProviderList&deletedProviderID='.$this->providerID.'&packageID='.PACKAGE_ID.SID_ARG_2ND_NOT_ENCODED);
		exit;
	}
}
?>