<?php
// wcf imports
require_once(WCF_DIR.'lib/action/AbstractAction.class.php');
require_once(WCF_DIR.'lib/data/socialBookmark/SocialBookmarkProviderEditor.class.php');

/**
 * Changes the sort order of a social bookmark provider.
 * 
 * @author	Alexander Ebert
 * @copyright	2001-2010 WoltLab GmbH
 * @license	GNU Lesser General Public License <http://opensource.org/licenses/lgpl-license.php>
 * @package	com.woltlab.wcf.socialBookmarks
 * @subpackage	acp.action
 * @category 	Community Framework
 */
class SocialBookmarkProviderSortAction extends AbstractAction {
	public $providerID = 0;
	public $showOrder = 0;
	public $socialBookmarkProvider = null;
	
	/**
	 * @see Action::readParameters()
	 */
	public function readParameters() {
		parent::readParameters();
		
		if (isset($_REQUEST['providerID'])) $this->providerID = intval($_REQUEST['providerID']);
		$this->socialBookmarkProvider = new SocialBookmarkProviderEditor($this->providerID);
		if (!$this->socialBookmarkProvider->providerID) {
			throw new IllegalLinkException();
		}
		
		if (isset($_REQUEST['showOrder'])) $this->showOrder = intval($_REQUEST['showOrder']);
	}

	/**
	 * @see Action::execute()
	 */
	public function execute() {
		// check permission
		WCF::getUser()->checkPermission('admin.socialBookmark.canEditSocialBookmarkProvider');
		
		if ($this->showOrder) {
			$this->socialBookmarkProvider->update($this->socialBookmarkProvider->title, StringUtil::decodeHTML($this->socialBookmarkProvider->url), $this->socialBookmarkProvider->providerImage, $this->showOrder);
		}
		
		// clear cache
		WCF::getCache()->clear(WCF_DIR.'cache/', 'cache.socialBookmarkProvider.php');
		
		$this->executed();
	}
}
?>