<?php
// wcf imports
require_once(WCF_DIR.'lib/data/socialBookmark/SocialBookmarkProvider.class.php');

/**
 * Provides functions to create and edit the data of a social bookmark provider.
 * 
 * @author	Alexander Ebert
 * @copyright	2001-2010 WoltLab GmbH
 * @license	GNU Lesser General Public License <http://opensource.org/licenses/lgpl-license.php>
 * @package	com.woltlab.wcf.socialBookmarks
 * @subpackage	data
 * @category 	Community Framework
 */
class SocialBookmarkProviderEditor extends SocialBookmarkProvider {
	/**
	 * Creates a new social bookmark provider.
	 * 
	 * @param	string		$title
	 * @param	string		$url
	 * @param	string		$providerImage
	 * @param	integer		$showOrder
	 */
	public static function create($title, $url, $providerImage, $showOrder) {
		$sql = "INSERT INTO	wcf".WCF_N."_social_bookmark_provider
					(title, url, providerImage, showOrder)
			VALUES		('".escapeString($title)."',
					'".escapeString($url)."',
					'".escapeString($providerImage)."',
					".$showOrder.")";
		WCF::getDB()->sendQuery($sql);
		
		$providerID = WCF::getDB()->getInsertID();
		return new SocialBookmarkProvider($providerID);
	}
	
	/**
	 * Updates this social bookmark provider.
	 * 
	 * @param	string		$title
	 * @param	string		$url
	 * @param	string		$providerImage
	 * @param	integer		$showOrder
	 */
	public function update($title, $url, $providerImage, $showOrder) {
		$sql = "UPDATE	wcf".WCF_N."_social_bookmark_provider
			SET	title = '".escapeString($title)."',
				url = '".escapeString($url)."',
				providerImage = '".escapeString($providerImage)."',
				showOrder = ".$showOrder."
			WHERE	providerID = ".$this->providerID;
		WCF::getDB()->sendQuery($sql);
	}
	
	/**
	 * Deletes this social bookmark provider.
	 */
	public function delete() {
		$sql = "DELETE FROM	wcf".WCF_N."_social_bookmark_provider
			WHERE		providerID = ".$this->providerID;
		WCF::getDB()->sendQuery($sql);
	}
	
	/**
	 * Enables/Disables a sociam bookmark provider.
	 *
	 * @param	boolean		$enable
	 */
	public function enable($enable) {
		$sql = "UPDATE	wcf".WCF_N."_social_bookmark_provider
			SET	enabled = ".intval($enable)."
			WHERE	providerID = ".$this->providerID;
		WCF::getDB()->sendQuery($sql);
	}
}
?>